/* Autogenerated file. Do not edit manually. */
/* tslint:disable */
/* eslint-disable */

import { Contract, ContractTransaction, EventFilter, Signer } from 'ethers';
import { Listener, Provider } from 'ethers/providers';
import { Arrayish, BigNumber, BigNumberish, Interface } from 'ethers/utils';
import {
  TransactionOverrides,
  TypedEventDescription,
  TypedFunctionDescription,
} from '.';

interface WrappedAssetInterface extends Interface {
  functions: {
    assetAddress: TypedFunctionDescription<{ encode([]: []): string }>;

    assetChain: TypedFunctionDescription<{ encode([]: []): string }>;

    bridge: TypedFunctionDescription<{ encode([]: []): string }>;

    initialized: TypedFunctionDescription<{ encode([]: []): string }>;

    initialize: TypedFunctionDescription<{
      encode([_assetChain, _assetAddress, decimals]: [
        BigNumberish,
        Arrayish,
        BigNumberish,
      ]): string;
    }>;

    mint: TypedFunctionDescription<{
      encode([account, amount]: [string, BigNumberish]): string;
    }>;

    burn: TypedFunctionDescription<{
      encode([account, amount]: [string, BigNumberish]): string;
    }>;

    name: TypedFunctionDescription<{ encode([]: []): string }>;

    symbol: TypedFunctionDescription<{ encode([]: []): string }>;

    decimals: TypedFunctionDescription<{ encode([]: []): string }>;

    totalSupply: TypedFunctionDescription<{ encode([]: []): string }>;

    balanceOf: TypedFunctionDescription<{
      encode([account]: [string]): string;
    }>;

    transfer: TypedFunctionDescription<{
      encode([recipient, amount]: [string, BigNumberish]): string;
    }>;

    allowance: TypedFunctionDescription<{
      encode([owner, spender]: [string, string]): string;
    }>;

    approve: TypedFunctionDescription<{
      encode([spender, amount]: [string, BigNumberish]): string;
    }>;

    transferFrom: TypedFunctionDescription<{
      encode([sender, recipient, amount]: [
        string,
        string,
        BigNumberish,
      ]): string;
    }>;

    increaseAllowance: TypedFunctionDescription<{
      encode([spender, addedValue]: [string, BigNumberish]): string;
    }>;

    decreaseAllowance: TypedFunctionDescription<{
      encode([spender, subtractedValue]: [string, BigNumberish]): string;
    }>;
  };

  events: {
    Approval: TypedEventDescription<{
      encodeTopics([owner, spender, value]: [
        string | null,
        string | null,
        null,
      ]): string[];
    }>;

    Transfer: TypedEventDescription<{
      encodeTopics([from, to, value]: [
        string | null,
        string | null,
        null,
      ]): string[];
    }>;
  };
}

export class WrappedAsset extends Contract {
  connect(signerOrProvider: Signer | Provider | string): WrappedAsset;
  attach(addressOrName: string): WrappedAsset;
  deployed(): Promise<WrappedAsset>;

  on(event: EventFilter | string, listener: Listener): WrappedAsset;
  once(event: EventFilter | string, listener: Listener): WrappedAsset;
  addListener(
    eventName: EventFilter | string,
    listener: Listener,
  ): WrappedAsset;
  removeAllListeners(eventName: EventFilter | string): WrappedAsset;
  removeListener(eventName: any, listener: Listener): WrappedAsset;

  interface: WrappedAssetInterface;

  functions: {
    assetAddress(overrides?: TransactionOverrides): Promise<string>;

    'assetAddress()'(overrides?: TransactionOverrides): Promise<string>;

    assetChain(overrides?: TransactionOverrides): Promise<number>;

    'assetChain()'(overrides?: TransactionOverrides): Promise<number>;

    bridge(overrides?: TransactionOverrides): Promise<string>;

    'bridge()'(overrides?: TransactionOverrides): Promise<string>;

    initialized(overrides?: TransactionOverrides): Promise<boolean>;

    'initialized()'(overrides?: TransactionOverrides): Promise<boolean>;

    initialize(
      _assetChain: BigNumberish,
      _assetAddress: Arrayish,
      decimals: BigNumberish,
      overrides?: TransactionOverrides,
    ): Promise<ContractTransaction>;

    'initialize(uint8,bytes32,uint8)'(
      _assetChain: BigNumberish,
      _assetAddress: Arrayish,
      decimals: BigNumberish,
      overrides?: TransactionOverrides,
    ): Promise<ContractTransaction>;

    mint(
      account: string,
      amount: BigNumberish,
      overrides?: TransactionOverrides,
    ): Promise<ContractTransaction>;

    'mint(address,uint256)'(
      account: string,
      amount: BigNumberish,
      overrides?: TransactionOverrides,
    ): Promise<ContractTransaction>;

    burn(
      account: string,
      amount: BigNumberish,
      overrides?: TransactionOverrides,
    ): Promise<ContractTransaction>;

    'burn(address,uint256)'(
      account: string,
      amount: BigNumberish,
      overrides?: TransactionOverrides,
    ): Promise<ContractTransaction>;

    /**
     * Returns the name of the token.
     */
    name(overrides?: TransactionOverrides): Promise<string>;

    /**
     * Returns the name of the token.
     */
    'name()'(overrides?: TransactionOverrides): Promise<string>;

    /**
     * Returns the symbol of the token, usually a shorter version of the name.
     */
    symbol(overrides?: TransactionOverrides): Promise<string>;

    /**
     * Returns the symbol of the token, usually a shorter version of the name.
     */
    'symbol()'(overrides?: TransactionOverrides): Promise<string>;

    /**
     * Returns the number of decimals used to get its user representation. For example, if `decimals` equals `2`, a balance of `505` tokens should be displayed to a user as `5,05` (`505 / 10 ** 2`). Tokens usually opt for a value of 18, imitating the relationship between Ether and Wei. This is the value {ERC20} uses, unless {_setupDecimals} is called. NOTE: This information is only used for _display_ purposes: it in no way affects any of the arithmetic of the contract, including {IERC20-balanceOf} and {IERC20-transfer}.
     */
    decimals(overrides?: TransactionOverrides): Promise<number>;

    /**
     * Returns the number of decimals used to get its user representation. For example, if `decimals` equals `2`, a balance of `505` tokens should be displayed to a user as `5,05` (`505 / 10 ** 2`). Tokens usually opt for a value of 18, imitating the relationship between Ether and Wei. This is the value {ERC20} uses, unless {_setupDecimals} is called. NOTE: This information is only used for _display_ purposes: it in no way affects any of the arithmetic of the contract, including {IERC20-balanceOf} and {IERC20-transfer}.
     */
    'decimals()'(overrides?: TransactionOverrides): Promise<number>;

    /**
     * See {IERC20-totalSupply}.
     */
    totalSupply(overrides?: TransactionOverrides): Promise<BigNumber>;

    /**
     * See {IERC20-totalSupply}.
     */
    'totalSupply()'(overrides?: TransactionOverrides): Promise<BigNumber>;

    /**
     * See {IERC20-balanceOf}.
     */
    balanceOf(
      account: string,
      overrides?: TransactionOverrides,
    ): Promise<BigNumber>;

    /**
     * See {IERC20-balanceOf}.
     */
    'balanceOf(address)'(
      account: string,
      overrides?: TransactionOverrides,
    ): Promise<BigNumber>;

    /**
     * See {IERC20-transfer}. Requirements: - `recipient` cannot be the zero address. - the caller must have a balance of at least `amount`.
     */
    transfer(
      recipient: string,
      amount: BigNumberish,
      overrides?: TransactionOverrides,
    ): Promise<ContractTransaction>;

    /**
     * See {IERC20-transfer}. Requirements: - `recipient` cannot be the zero address. - the caller must have a balance of at least `amount`.
     */
    'transfer(address,uint256)'(
      recipient: string,
      amount: BigNumberish,
      overrides?: TransactionOverrides,
    ): Promise<ContractTransaction>;

    /**
     * See {IERC20-allowance}.
     */
    allowance(
      owner: string,
      spender: string,
      overrides?: TransactionOverrides,
    ): Promise<BigNumber>;

    /**
     * See {IERC20-allowance}.
     */
    'allowance(address,address)'(
      owner: string,
      spender: string,
      overrides?: TransactionOverrides,
    ): Promise<BigNumber>;

    /**
     * See {IERC20-approve}. Requirements: - `spender` cannot be the zero address.
     */
    approve(
      spender: string,
      amount: BigNumberish,
      overrides?: TransactionOverrides,
    ): Promise<ContractTransaction>;

    /**
     * See {IERC20-approve}. Requirements: - `spender` cannot be the zero address.
     */
    'approve(address,uint256)'(
      spender: string,
      amount: BigNumberish,
      overrides?: TransactionOverrides,
    ): Promise<ContractTransaction>;

    /**
     * See {IERC20-transferFrom}. Emits an {Approval} event indicating the updated allowance. This is not required by the EIP. See the note at the beginning of {ERC20}; Requirements: - `sender` and `recipient` cannot be the zero address. - `sender` must have a balance of at least `amount`. - the caller must have allowance for ``sender``'s tokens of at least `amount`.
     */
    transferFrom(
      sender: string,
      recipient: string,
      amount: BigNumberish,
      overrides?: TransactionOverrides,
    ): Promise<ContractTransaction>;

    /**
     * See {IERC20-transferFrom}. Emits an {Approval} event indicating the updated allowance. This is not required by the EIP. See the note at the beginning of {ERC20}; Requirements: - `sender` and `recipient` cannot be the zero address. - `sender` must have a balance of at least `amount`. - the caller must have allowance for ``sender``'s tokens of at least `amount`.
     */
    'transferFrom(address,address,uint256)'(
      sender: string,
      recipient: string,
      amount: BigNumberish,
      overrides?: TransactionOverrides,
    ): Promise<ContractTransaction>;

    /**
     * Atomically increases the allowance granted to `spender` by the caller. This is an alternative to {approve} that can be used as a mitigation for problems described in {IERC20-approve}. Emits an {Approval} event indicating the updated allowance. Requirements: - `spender` cannot be the zero address.
     */
    increaseAllowance(
      spender: string,
      addedValue: BigNumberish,
      overrides?: TransactionOverrides,
    ): Promise<ContractTransaction>;

    /**
     * Atomically increases the allowance granted to `spender` by the caller. This is an alternative to {approve} that can be used as a mitigation for problems described in {IERC20-approve}. Emits an {Approval} event indicating the updated allowance. Requirements: - `spender` cannot be the zero address.
     */
    'increaseAllowance(address,uint256)'(
      spender: string,
      addedValue: BigNumberish,
      overrides?: TransactionOverrides,
    ): Promise<ContractTransaction>;

    /**
     * Atomically decreases the allowance granted to `spender` by the caller. This is an alternative to {approve} that can be used as a mitigation for problems described in {IERC20-approve}. Emits an {Approval} event indicating the updated allowance. Requirements: - `spender` cannot be the zero address. - `spender` must have allowance for the caller of at least `subtractedValue`.
     */
    decreaseAllowance(
      spender: string,
      subtractedValue: BigNumberish,
      overrides?: TransactionOverrides,
    ): Promise<ContractTransaction>;

    /**
     * Atomically decreases the allowance granted to `spender` by the caller. This is an alternative to {approve} that can be used as a mitigation for problems described in {IERC20-approve}. Emits an {Approval} event indicating the updated allowance. Requirements: - `spender` cannot be the zero address. - `spender` must have allowance for the caller of at least `subtractedValue`.
     */
    'decreaseAllowance(address,uint256)'(
      spender: string,
      subtractedValue: BigNumberish,
      overrides?: TransactionOverrides,
    ): Promise<ContractTransaction>;
  };

  assetAddress(overrides?: TransactionOverrides): Promise<string>;

  'assetAddress()'(overrides?: TransactionOverrides): Promise<string>;

  assetChain(overrides?: TransactionOverrides): Promise<number>;

  'assetChain()'(overrides?: TransactionOverrides): Promise<number>;

  bridge(overrides?: TransactionOverrides): Promise<string>;

  'bridge()'(overrides?: TransactionOverrides): Promise<string>;

  initialized(overrides?: TransactionOverrides): Promise<boolean>;

  'initialized()'(overrides?: TransactionOverrides): Promise<boolean>;

  initialize(
    _assetChain: BigNumberish,
    _assetAddress: Arrayish,
    decimals: BigNumberish,
    overrides?: TransactionOverrides,
  ): Promise<ContractTransaction>;

  'initialize(uint8,bytes32,uint8)'(
    _assetChain: BigNumberish,
    _assetAddress: Arrayish,
    decimals: BigNumberish,
    overrides?: TransactionOverrides,
  ): Promise<ContractTransaction>;

  mint(
    account: string,
    amount: BigNumberish,
    overrides?: TransactionOverrides,
  ): Promise<ContractTransaction>;

  'mint(address,uint256)'(
    account: string,
    amount: BigNumberish,
    overrides?: TransactionOverrides,
  ): Promise<ContractTransaction>;

  burn(
    account: string,
    amount: BigNumberish,
    overrides?: TransactionOverrides,
  ): Promise<ContractTransaction>;

  'burn(address,uint256)'(
    account: string,
    amount: BigNumberish,
    overrides?: TransactionOverrides,
  ): Promise<ContractTransaction>;

  /**
   * Returns the name of the token.
   */
  name(overrides?: TransactionOverrides): Promise<string>;

  /**
   * Returns the name of the token.
   */
  'name()'(overrides?: TransactionOverrides): Promise<string>;

  /**
   * Returns the symbol of the token, usually a shorter version of the name.
   */
  symbol(overrides?: TransactionOverrides): Promise<string>;

  /**
   * Returns the symbol of the token, usually a shorter version of the name.
   */
  'symbol()'(overrides?: TransactionOverrides): Promise<string>;

  /**
   * Returns the number of decimals used to get its user representation. For example, if `decimals` equals `2`, a balance of `505` tokens should be displayed to a user as `5,05` (`505 / 10 ** 2`). Tokens usually opt for a value of 18, imitating the relationship between Ether and Wei. This is the value {ERC20} uses, unless {_setupDecimals} is called. NOTE: This information is only used for _display_ purposes: it in no way affects any of the arithmetic of the contract, including {IERC20-balanceOf} and {IERC20-transfer}.
   */
  decimals(overrides?: TransactionOverrides): Promise<number>;

  /**
   * Returns the number of decimals used to get its user representation. For example, if `decimals` equals `2`, a balance of `505` tokens should be displayed to a user as `5,05` (`505 / 10 ** 2`). Tokens usually opt for a value of 18, imitating the relationship between Ether and Wei. This is the value {ERC20} uses, unless {_setupDecimals} is called. NOTE: This information is only used for _display_ purposes: it in no way affects any of the arithmetic of the contract, including {IERC20-balanceOf} and {IERC20-transfer}.
   */
  'decimals()'(overrides?: TransactionOverrides): Promise<number>;

  /**
   * See {IERC20-totalSupply}.
   */
  totalSupply(overrides?: TransactionOverrides): Promise<BigNumber>;

  /**
   * See {IERC20-totalSupply}.
   */
  'totalSupply()'(overrides?: TransactionOverrides): Promise<BigNumber>;

  /**
   * See {IERC20-balanceOf}.
   */
  balanceOf(
    account: string,
    overrides?: TransactionOverrides,
  ): Promise<BigNumber>;

  /**
   * See {IERC20-balanceOf}.
   */
  'balanceOf(address)'(
    account: string,
    overrides?: TransactionOverrides,
  ): Promise<BigNumber>;

  /**
   * See {IERC20-transfer}. Requirements: - `recipient` cannot be the zero address. - the caller must have a balance of at least `amount`.
   */
  transfer(
    recipient: string,
    amount: BigNumberish,
    overrides?: TransactionOverrides,
  ): Promise<ContractTransaction>;

  /**
   * See {IERC20-transfer}. Requirements: - `recipient` cannot be the zero address. - the caller must have a balance of at least `amount`.
   */
  'transfer(address,uint256)'(
    recipient: string,
    amount: BigNumberish,
    overrides?: TransactionOverrides,
  ): Promise<ContractTransaction>;

  /**
   * See {IERC20-allowance}.
   */
  allowance(
    owner: string,
    spender: string,
    overrides?: TransactionOverrides,
  ): Promise<BigNumber>;

  /**
   * See {IERC20-allowance}.
   */
  'allowance(address,address)'(
    owner: string,
    spender: string,
    overrides?: TransactionOverrides,
  ): Promise<BigNumber>;

  /**
   * See {IERC20-approve}. Requirements: - `spender` cannot be the zero address.
   */
  approve(
    spender: string,
    amount: BigNumberish,
    overrides?: TransactionOverrides,
  ): Promise<ContractTransaction>;

  /**
   * See {IERC20-approve}. Requirements: - `spender` cannot be the zero address.
   */
  'approve(address,uint256)'(
    spender: string,
    amount: BigNumberish,
    overrides?: TransactionOverrides,
  ): Promise<ContractTransaction>;

  /**
   * See {IERC20-transferFrom}. Emits an {Approval} event indicating the updated allowance. This is not required by the EIP. See the note at the beginning of {ERC20}; Requirements: - `sender` and `recipient` cannot be the zero address. - `sender` must have a balance of at least `amount`. - the caller must have allowance for ``sender``'s tokens of at least `amount`.
   */
  transferFrom(
    sender: string,
    recipient: string,
    amount: BigNumberish,
    overrides?: TransactionOverrides,
  ): Promise<ContractTransaction>;

  /**
   * See {IERC20-transferFrom}. Emits an {Approval} event indicating the updated allowance. This is not required by the EIP. See the note at the beginning of {ERC20}; Requirements: - `sender` and `recipient` cannot be the zero address. - `sender` must have a balance of at least `amount`. - the caller must have allowance for ``sender``'s tokens of at least `amount`.
   */
  'transferFrom(address,address,uint256)'(
    sender: string,
    recipient: string,
    amount: BigNumberish,
    overrides?: TransactionOverrides,
  ): Promise<ContractTransaction>;

  /**
   * Atomically increases the allowance granted to `spender` by the caller. This is an alternative to {approve} that can be used as a mitigation for problems described in {IERC20-approve}. Emits an {Approval} event indicating the updated allowance. Requirements: - `spender` cannot be the zero address.
   */
  increaseAllowance(
    spender: string,
    addedValue: BigNumberish,
    overrides?: TransactionOverrides,
  ): Promise<ContractTransaction>;

  /**
   * Atomically increases the allowance granted to `spender` by the caller. This is an alternative to {approve} that can be used as a mitigation for problems described in {IERC20-approve}. Emits an {Approval} event indicating the updated allowance. Requirements: - `spender` cannot be the zero address.
   */
  'increaseAllowance(address,uint256)'(
    spender: string,
    addedValue: BigNumberish,
    overrides?: TransactionOverrides,
  ): Promise<ContractTransaction>;

  /**
   * Atomically decreases the allowance granted to `spender` by the caller. This is an alternative to {approve} that can be used as a mitigation for problems described in {IERC20-approve}. Emits an {Approval} event indicating the updated allowance. Requirements: - `spender` cannot be the zero address. - `spender` must have allowance for the caller of at least `subtractedValue`.
   */
  decreaseAllowance(
    spender: string,
    subtractedValue: BigNumberish,
    overrides?: TransactionOverrides,
  ): Promise<ContractTransaction>;

  /**
   * Atomically decreases the allowance granted to `spender` by the caller. This is an alternative to {approve} that can be used as a mitigation for problems described in {IERC20-approve}. Emits an {Approval} event indicating the updated allowance. Requirements: - `spender` cannot be the zero address. - `spender` must have allowance for the caller of at least `subtractedValue`.
   */
  'decreaseAllowance(address,uint256)'(
    spender: string,
    subtractedValue: BigNumberish,
    overrides?: TransactionOverrides,
  ): Promise<ContractTransaction>;

  filters: {
    Approval(
      owner: string | null,
      spender: string | null,
      value: null,
    ): EventFilter;

    Transfer(from: string | null, to: string | null, value: null): EventFilter;
  };

  estimate: {
    assetAddress(overrides?: TransactionOverrides): Promise<BigNumber>;

    'assetAddress()'(overrides?: TransactionOverrides): Promise<BigNumber>;

    assetChain(overrides?: TransactionOverrides): Promise<BigNumber>;

    'assetChain()'(overrides?: TransactionOverrides): Promise<BigNumber>;

    bridge(overrides?: TransactionOverrides): Promise<BigNumber>;

    'bridge()'(overrides?: TransactionOverrides): Promise<BigNumber>;

    initialized(overrides?: TransactionOverrides): Promise<BigNumber>;

    'initialized()'(overrides?: TransactionOverrides): Promise<BigNumber>;

    initialize(
      _assetChain: BigNumberish,
      _assetAddress: Arrayish,
      decimals: BigNumberish,
      overrides?: TransactionOverrides,
    ): Promise<BigNumber>;

    'initialize(uint8,bytes32,uint8)'(
      _assetChain: BigNumberish,
      _assetAddress: Arrayish,
      decimals: BigNumberish,
      overrides?: TransactionOverrides,
    ): Promise<BigNumber>;

    mint(
      account: string,
      amount: BigNumberish,
      overrides?: TransactionOverrides,
    ): Promise<BigNumber>;

    'mint(address,uint256)'(
      account: string,
      amount: BigNumberish,
      overrides?: TransactionOverrides,
    ): Promise<BigNumber>;

    burn(
      account: string,
      amount: BigNumberish,
      overrides?: TransactionOverrides,
    ): Promise<BigNumber>;

    'burn(address,uint256)'(
      account: string,
      amount: BigNumberish,
      overrides?: TransactionOverrides,
    ): Promise<BigNumber>;

    /**
     * Returns the name of the token.
     */
    name(overrides?: TransactionOverrides): Promise<BigNumber>;

    /**
     * Returns the name of the token.
     */
    'name()'(overrides?: TransactionOverrides): Promise<BigNumber>;

    /**
     * Returns the symbol of the token, usually a shorter version of the name.
     */
    symbol(overrides?: TransactionOverrides): Promise<BigNumber>;

    /**
     * Returns the symbol of the token, usually a shorter version of the name.
     */
    'symbol()'(overrides?: TransactionOverrides): Promise<BigNumber>;

    /**
     * Returns the number of decimals used to get its user representation. For example, if `decimals` equals `2`, a balance of `505` tokens should be displayed to a user as `5,05` (`505 / 10 ** 2`). Tokens usually opt for a value of 18, imitating the relationship between Ether and Wei. This is the value {ERC20} uses, unless {_setupDecimals} is called. NOTE: This information is only used for _display_ purposes: it in no way affects any of the arithmetic of the contract, including {IERC20-balanceOf} and {IERC20-transfer}.
     */
    decimals(overrides?: TransactionOverrides): Promise<BigNumber>;

    /**
     * Returns the number of decimals used to get its user representation. For example, if `decimals` equals `2`, a balance of `505` tokens should be displayed to a user as `5,05` (`505 / 10 ** 2`). Tokens usually opt for a value of 18, imitating the relationship between Ether and Wei. This is the value {ERC20} uses, unless {_setupDecimals} is called. NOTE: This information is only used for _display_ purposes: it in no way affects any of the arithmetic of the contract, including {IERC20-balanceOf} and {IERC20-transfer}.
     */
    'decimals()'(overrides?: TransactionOverrides): Promise<BigNumber>;

    /**
     * See {IERC20-totalSupply}.
     */
    totalSupply(overrides?: TransactionOverrides): Promise<BigNumber>;

    /**
     * See {IERC20-totalSupply}.
     */
    'totalSupply()'(overrides?: TransactionOverrides): Promise<BigNumber>;

    /**
     * See {IERC20-balanceOf}.
     */
    balanceOf(
      account: string,
      overrides?: TransactionOverrides,
    ): Promise<BigNumber>;

    /**
     * See {IERC20-balanceOf}.
     */
    'balanceOf(address)'(
      account: string,
      overrides?: TransactionOverrides,
    ): Promise<BigNumber>;

    /**
     * See {IERC20-transfer}. Requirements: - `recipient` cannot be the zero address. - the caller must have a balance of at least `amount`.
     */
    transfer(
      recipient: string,
      amount: BigNumberish,
      overrides?: TransactionOverrides,
    ): Promise<BigNumber>;

    /**
     * See {IERC20-transfer}. Requirements: - `recipient` cannot be the zero address. - the caller must have a balance of at least `amount`.
     */
    'transfer(address,uint256)'(
      recipient: string,
      amount: BigNumberish,
      overrides?: TransactionOverrides,
    ): Promise<BigNumber>;

    /**
     * See {IERC20-allowance}.
     */
    allowance(
      owner: string,
      spender: string,
      overrides?: TransactionOverrides,
    ): Promise<BigNumber>;

    /**
     * See {IERC20-allowance}.
     */
    'allowance(address,address)'(
      owner: string,
      spender: string,
      overrides?: TransactionOverrides,
    ): Promise<BigNumber>;

    /**
     * See {IERC20-approve}. Requirements: - `spender` cannot be the zero address.
     */
    approve(
      spender: string,
      amount: BigNumberish,
      overrides?: TransactionOverrides,
    ): Promise<BigNumber>;

    /**
     * See {IERC20-approve}. Requirements: - `spender` cannot be the zero address.
     */
    'approve(address,uint256)'(
      spender: string,
      amount: BigNumberish,
      overrides?: TransactionOverrides,
    ): Promise<BigNumber>;

    /**
     * See {IERC20-transferFrom}. Emits an {Approval} event indicating the updated allowance. This is not required by the EIP. See the note at the beginning of {ERC20}; Requirements: - `sender` and `recipient` cannot be the zero address. - `sender` must have a balance of at least `amount`. - the caller must have allowance for ``sender``'s tokens of at least `amount`.
     */
    transferFrom(
      sender: string,
      recipient: string,
      amount: BigNumberish,
      overrides?: TransactionOverrides,
    ): Promise<BigNumber>;

    /**
     * See {IERC20-transferFrom}. Emits an {Approval} event indicating the updated allowance. This is not required by the EIP. See the note at the beginning of {ERC20}; Requirements: - `sender` and `recipient` cannot be the zero address. - `sender` must have a balance of at least `amount`. - the caller must have allowance for ``sender``'s tokens of at least `amount`.
     */
    'transferFrom(address,address,uint256)'(
      sender: string,
      recipient: string,
      amount: BigNumberish,
      overrides?: TransactionOverrides,
    ): Promise<BigNumber>;

    /**
     * Atomically increases the allowance granted to `spender` by the caller. This is an alternative to {approve} that can be used as a mitigation for problems described in {IERC20-approve}. Emits an {Approval} event indicating the updated allowance. Requirements: - `spender` cannot be the zero address.
     */
    increaseAllowance(
      spender: string,
      addedValue: BigNumberish,
      overrides?: TransactionOverrides,
    ): Promise<BigNumber>;

    /**
     * Atomically increases the allowance granted to `spender` by the caller. This is an alternative to {approve} that can be used as a mitigation for problems described in {IERC20-approve}. Emits an {Approval} event indicating the updated allowance. Requirements: - `spender` cannot be the zero address.
     */
    'increaseAllowance(address,uint256)'(
      spender: string,
      addedValue: BigNumberish,
      overrides?: TransactionOverrides,
    ): Promise<BigNumber>;

    /**
     * Atomically decreases the allowance granted to `spender` by the caller. This is an alternative to {approve} that can be used as a mitigation for problems described in {IERC20-approve}. Emits an {Approval} event indicating the updated allowance. Requirements: - `spender` cannot be the zero address. - `spender` must have allowance for the caller of at least `subtractedValue`.
     */
    decreaseAllowance(
      spender: string,
      subtractedValue: BigNumberish,
      overrides?: TransactionOverrides,
    ): Promise<BigNumber>;

    /**
     * Atomically decreases the allowance granted to `spender` by the caller. This is an alternative to {approve} that can be used as a mitigation for problems described in {IERC20-approve}. Emits an {Approval} event indicating the updated allowance. Requirements: - `spender` cannot be the zero address. - `spender` must have allowance for the caller of at least `subtractedValue`.
     */
    'decreaseAllowance(address,uint256)'(
      spender: string,
      subtractedValue: BigNumberish,
      overrides?: TransactionOverrides,
    ): Promise<BigNumber>;
  };
}
